import * as _unocss_core from '@unocss/core';
import { RGBAColorValue, CSSColorValue, VariantObject } from '@unocss/core';
export { C as CONTROL_MINI_NO_NEGATIVE, c as colorResolver, a as colorableShadows, d as directionSize, h as hasParseableColor, p as parseColor, r as resolveBreakpoints, b as resolveVerticalBreakpoints } from './utilities-e7a7f845.js';
import './types-f7b2c653.js';

declare function hex2rgba(hex?: string): RGBAColorValue | undefined;
declare function parseCssColor(str?: string): CSSColorValue | undefined;
declare function colorToString(color: CSSColorValue, alphaOverride?: string | number): string;
declare function getComponents(str: string, separator?: string, limit?: number): string[] | undefined;

declare const directionMap: Record<string, string[]>;
declare const insetMap: Record<string, string[]>;
declare const cornerMap: Record<string, string[]>;
declare const xyzMap: Record<string, string[]>;
declare const positionMap: Record<string, string>;

declare function numberWithUnit(str: string): string | undefined;
declare function auto(str: string): "auto" | undefined;
declare function rem(str: string): string | undefined;
declare function px(str: string): string | undefined;
declare function number(str: string): string | undefined;
declare function percent(str: string): string | undefined;
declare function fraction(str: string): string | undefined;
declare function bracket(str: string): string | undefined;
declare function bracketOfColor(str: string): string | undefined;
declare function bracketOfLength(str: string): string | undefined;
declare function cssvar(str: string): string | undefined;
declare function time(str: string): string | undefined;
declare function degree(str: string): string | undefined;
declare function global(str: string): string | undefined;
declare function properties(str: string): string | undefined;

declare const handlers_numberWithUnit: typeof numberWithUnit;
declare const handlers_auto: typeof auto;
declare const handlers_rem: typeof rem;
declare const handlers_px: typeof px;
declare const handlers_number: typeof number;
declare const handlers_percent: typeof percent;
declare const handlers_fraction: typeof fraction;
declare const handlers_bracket: typeof bracket;
declare const handlers_bracketOfColor: typeof bracketOfColor;
declare const handlers_bracketOfLength: typeof bracketOfLength;
declare const handlers_cssvar: typeof cssvar;
declare const handlers_time: typeof time;
declare const handlers_degree: typeof degree;
declare const handlers_global: typeof global;
declare const handlers_properties: typeof properties;
declare namespace handlers {
  export {
    handlers_numberWithUnit as numberWithUnit,
    handlers_auto as auto,
    handlers_rem as rem,
    handlers_px as px,
    handlers_number as number,
    handlers_percent as percent,
    handlers_fraction as fraction,
    handlers_bracket as bracket,
    handlers_bracketOfColor as bracketOfColor,
    handlers_bracketOfLength as bracketOfLength,
    handlers_cssvar as cssvar,
    handlers_time as time,
    handlers_degree as degree,
    handlers_global as global,
    handlers_properties as properties,
  };
}

declare const handler: _unocss_core.ValueHandler<"number" | "global" | "auto" | "numberWithUnit" | "rem" | "px" | "percent" | "fraction" | "bracket" | "bracketOfColor" | "bracketOfLength" | "cssvar" | "time" | "degree" | "properties">;
declare const h: _unocss_core.ValueHandler<"number" | "global" | "auto" | "numberWithUnit" | "rem" | "px" | "percent" | "fraction" | "bracket" | "bracketOfColor" | "bracketOfLength" | "cssvar" | "time" | "degree" | "properties">;

declare const variantMatcher: (name: string, selector?: ((input: string) => string | undefined) | undefined) => VariantObject;
declare const variantParentMatcher: (name: string, parent: string) => VariantObject;

export { colorToString, cornerMap, directionMap, getComponents, h, handler, hex2rgba, insetMap, parseCssColor, positionMap, handlers as valueHandlers, variantMatcher, variantParentMatcher, xyzMap };
